



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spring整合MyBatis（三）sqlSessionFactory创建</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spring整合MyBatis（三）sqlSessionFactory创建</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 03:55:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>摘要: 本文结合《Spring源码深度解析》来分析Spring 5.0.6版本的源代码。若有描述错误之处，欢迎指正。</p></blockquote>
<h1>目录</h1>
<p>一、SqlSessionFactoryBean的初始化</p>
<p>二、获取 SqlSessionFactoryBean 实例</p>
<p>通过Spring整合MyBatis的示例，我们感受到了Spring为用户更加快捷地进行开发所做的努力，开发人员的工作效率由此得到了显著的提升。但是，相对于使用来说，我们更想知道其背后所隐藏的秘密，Spring整合MyBatis是如何实现的呢？通过分析整合示例中的配置文件，我们可以知道配置的bean其实是成树状结构的，而在树的最顶层是类型为org.mybatis.spring.SqlSessionFactoryBean的bean，它将其他相关bean组装在了一起，那么，我们的分析就从此类开始。</p>
<p>通过配置文件我们分析，对于配置文件的读取解析，Spring应该通过org.mybatis.spring.SqlSessionFactoryBean封装了MyBatis中的实现。我们进入这个类，首先査看这个类的层次结构，如下图所示。</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/963903/201808/963903-20180808205508210-1401430608.png" /></p>
<p>根据这个类的层次结构找出我们感兴趣的两个接口，FactoryBean和InitializingBean：</p>
<ul><li>InitializingBean：实现此接口的bean会在初始化时调用其afterPropertiesSet方法来进行bean的逻辑初始化。</li>
<li>FactoryBean：一旦某个bean实现此接口，那么通过getBean方法获取bean时其实是获取此类的getObject()返回的实例。</li></ul>
<p>我们首先以InitializingBean接口的afterPropertiesSet()方法作为突破点。</p>
<h1>一、SqlSessionFactoryBean的初始化</h1>
<p>査看org.mybatis.spring.SqlSessionFactoryBean类型的bean在初始化时做了哪些逻辑实现。</p>
<div>
<pre class="prettyprint linenums">@Override<br />
public void afterPropertiesSet() throws Exception {<br />
    notNull(dataSource, "Property 'dataSource' is required");<br />
    notNull(sqlSessionFactoryBuilder, "Property 'sqlSessionFactoryBuilder' is required");<br />
    state((configuration == null &amp;&amp; configLocation == null) || !(configuration != null &amp;&amp; configLocation != null),<br />
            "Property 'configuration' and 'configLocation' can not specified with together");

    this.sqlSessionFactory =<strong> buildSqlSessionFactory</strong>();<br />
}</pre>
</div>
<p>很显然，此函数主要目的就是对于sqlSessionFactory的初始化，通过之前展示的独立使用MyBatis的示例，我们了解到SqlSessionFactory是所有MyBatis功能的基础。</p>
<div>
<pre class="prettyprint linenums">protected SqlSessionFactory buildSqlSessionFactory() throws IOException {

    Configuration configuration;

    XMLConfigBuilder xmlConfigBuilder = null;<br />
    if (this.configuration != null) {<br />
        configuration = this.configuration;<br />
        if (configuration.getVariables() == null) {<br />
            configuration.setVariables(this.configurationProperties);<br />
        } else if (this.configurationProperties != null) {<br />
            configuration.getVariables().putAll(this.configurationProperties);<br />
        }<br />
    } else if (this.configLocation != null) {<br />
        xmlConfigBuilder = new XMLConfigBuilder(this.configLocation.getInputStream(), null, this.configurationProperties);<br />
        configuration = xmlConfigBuilder.getConfiguration();<br />
    } else {<br />
        LOGGER.debug(() -&gt; "Property 'configuration' or 'configLocation' not specified, using default MyBatis Configuration");<br />
        configuration = new Configuration();<br />
        if (this.configurationProperties != null) {<br />
            configuration.setVariables(this.configurationProperties);<br />
        }<br />
    }

    if (this.objectFactory != null) {<br />
        configuration.setObjectFactory(this.objectFactory);<br />
    }

    if (this.objectWrapperFactory != null) {<br />
        configuration.setObjectWrapperFactory(this.objectWrapperFactory);<br />
    }

    if (this.vfs != null) {<br />
        configuration.setVfsImpl(this.vfs);<br />
    }

    if (hasLength(this.typeAliasesPackage)) {<br />
        String[] typeAliasPackageArray = tokenizeToStringArray(this.typeAliasesPackage,<br />
                ConfigurableApplicationContext.CONFIG_LOCATION_DELIMITERS);<br />
        for (String packageToScan : typeAliasPackageArray) {<br />
            configuration.getTypeAliasRegistry().registerAliases(packageToScan,<br />
                    typeAliasesSuperType == null ? Object.class : typeAliasesSuperType);<br />
            LOGGER.debug(() -&gt; "Scanned package: '" + packageToScan + "' for aliases");<br />
        }<br />
    }

    if (!isEmpty(this.typeAliases)) {<br />
        for (Class&lt;?&gt; typeAlias : this.typeAliases) {<br />
            configuration.getTypeAliasRegistry().registerAlias(typeAlias);<br />
            LOGGER.debug(() -&gt; "Registered type alias: '" + typeAlias + "'");<br />
        }<br />
    }

    if (!isEmpty(this.plugins)) {<br />
        for (Interceptor plugin : this.plugins) {<br />
            configuration.addInterceptor(plugin);<br />
            LOGGER.debug(() -&gt; "Registered plugin: '" + plugin + "'");<br />
        }<br />
    }

    if (hasLength(this.typeHandlersPackage)) {<br />
        String[] typeHandlersPackageArray = tokenizeToStringArray(this.typeHandlersPackage,<br />
                ConfigurableApplicationContext.CONFIG_LOCATION_DELIMITERS);<br />
        for (String packageToScan : typeHandlersPackageArray) {<br />
            configuration.getTypeHandlerRegistry().register(packageToScan);<br />
            LOGGER.debug(() -&gt; "Scanned package: '" + packageToScan + "' for type handlers");<br />
        }<br />
    }

    if (!isEmpty(this.typeHandlers)) {<br />
        for (TypeHandler&lt;?&gt; typeHandler : this.typeHandlers) {<br />
            configuration.getTypeHandlerRegistry().register(typeHandler);<br />
            LOGGER.debug(() -&gt; "Registered type handler: '" + typeHandler + "'");<br />
        }<br />
    }

    if (this.databaseIdProvider != null) {//fix #64 set databaseId before parse mapper xmls<br />
        try {<br />
            configuration.setDatabaseId(this.databaseIdProvider.getDatabaseId(this.dataSource));<br />
        } catch (SQLException e) {<br />
            throw new NestedIOException("Failed getting a databaseId", e);<br />
        }<br />
    }

    if (this.cache != null) {<br />
        configuration.addCache(this.cache);<br />
    }

    if (xmlConfigBuilder != null) {<br />
        try {<br />
            xmlConfigBuilder.parse();<br />
            LOGGER.debug(() -&gt; "Parsed configuration file: '" + this.configLocation + "'");<br />
        } catch (Exception ex) {<br />
            throw new NestedIOException("Failed to parse config resource: " + this.configLocation, ex);<br />
        } finally {<br />
            ErrorContext.instance().reset();<br />
        }<br />
    }

    if (this.transactionFactory == null) {<br />
        this.transactionFactory = new SpringManagedTransactionFactory();<br />
    }

    configuration.setEnvironment(new Environment(this.environment, this.transactionFactory, this.dataSource));

    if (!isEmpty(this.mapperLocations)) {<br />
        for (Resource mapperLocation : this.mapperLocations) {<br />
            if (mapperLocation == null) {<br />
                continue;<br />
            }

            try {<br />
                XMLMapperBuilder xmlMapperBuilder = new XMLMapperBuilder(mapperLocation.getInputStream(),<br />
                        configuration, mapperLocation.toString(), configuration.getSqlFragments());<br />
                xmlMapperBuilder.parse();<br />
            } catch (Exception e) {<br />
                throw new NestedIOException("Failed to parse mapping resource: '" + mapperLocation + "'", e);<br />
            } finally {<br />
                ErrorContext.instance().reset();<br />
            }<br />
            LOGGER.debug(() -&gt; "Parsed mapper file: '" + mapperLocation + "'");<br />
        }<br />
    } else {<br />
        LOGGER.debug(() -&gt; "Property 'mapperLocations' was not specified or no matching resources found");<br />
    }

    return this.sqlSessionFactoryBuilder.build(configuration);<br />
}</pre>
</div>
<p>从函数中可以看到，尽管我们还是习惯于将MyBatis的配置与Spring的配置独立开来，但是，这并不代表Spring中的配置不支持直接配置。也就是说，在上面提供的示例中，你完全可以取消配置中的configLocation，而把其中的属性直接写在SqlSessionFactoryBean中。</p>
<p>从这个函数中可以得知，配置文件还可以支持其他多种属性的配置，如configLocation、objectFactory、objectWrapperFactory、typeAliasesPackage、typeAliases、typeHandlersPackage、plugins、typeHandlers、transactionFactory、databaseIdProvider、mapperLocations。</p>
<p>其实，如果只按照常用的配置，那么我们只需要在函数最开始按照如下方式处理configuration：</p>
<div>
<pre class="prettyprint linenums">xmlConfigBuilder = new XMLConfigBuilder(this.configLocation.getInputStream(), null, this.configurationProperties);<br />
configuration = xmlConfigBuilder.getConfiguration();</pre>
</div>
<p>根据configLocation构造XMLConfigBuilder并进行解析，但是，为了体现Spring更强大的兼容性，Spring还整合了MyBatis中其他属性的注入，并通过实例configuration来承载每一步所获取的信息并最终使用sqlSessionFactoryBuilder实例根据解析到的configuration创建SqlSessionFactory实例。</p>
<h1>二、获取 SqlSessionFactoryBean 实例</h1>
<p>由于SqlSessionFactoryBean实现了FactoryBean接口，所以当通过getBean方法获取对应实例时，其实是获取该类的getObject()函数返回的实例，也就是获取初始化后的sqlSessionFactory属性。</p>
<div>
<pre class="prettyprint linenums">@Override<br />
public SqlSessionFactory getObject() throws Exception {<br />
    if (this.sqlSessionFactory == null) {<br />
        afterPropertiesSet();<br />
    }

    return this.sqlSessionFactory;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39rgn6e8.html">C语言 插入排序 算法导论chapter2</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdg36xq.html">【转】C&num;Winform程序如何发布并自动升级（图解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwm5kz8.html">json  转换错误&colon;JSON&period;parse expected property name or &amp;&num;39&semi;&rcub;&amp;&num;39&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1n6638.html">expr命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x14dn9.html">kill session真的能杀掉进程吗</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey1yjk9.html">js实现相册翻页，滚动，切换，轮播功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj5rkxq.html">Tcl与Design Compiler （九）&mdash;&mdash;综合后的形式验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pld5v8.html">设置为互斥按钮的一组Radio按钮的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1yxjzq.html">c&num;导出文件，文件名中文乱码解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meox40q.html">MySQL中的EXPLAIN</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1kx75q.html">安装yii2 需要token 记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyxyyn9.html">常用gcc选项</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rx5008.html">I - A&sol;B</a>
		</li>
						<li><a href="https://www.batexi.com/a/960rmev9.html">ASP&period;net MVC模式介绍（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvykjdq.html">Win7&sol;Win8&period;1右键菜单技巧：应用程序任意加</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jme05g9.html">JQuery Mobile 简单入门引导</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kovov5q.html">ORM创建 脚本运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvek0mo9.html">ASP&period;NET MVC ScriptBundle 不能加载&period;min&period;js文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/963w4pn9.html">32&period;使用来MethodFilterInterceptor灵活拦截</a>
		</li>
						<li><a href="https://www.batexi.com/a/95pxpzvq.html">关于鼠标不敏感导致自以为ubuntu很怪的问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qvejz6x9.html">listview更改选中时item背景色&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvejr5x9.html">使用display：none和visibility：hidden隐藏的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o43g1lq.html">移动端 vconsole 的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p7k6nq.html">CSS选择器之基本选择器&plus;属性选择器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p772nq.html">oracle 网络配置 及 pl&sol;sql 连接配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjgg4zq.html">java 内存分析之方法返回值及匿名对象一</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvej3oj9.html">7 Recursive AutoEncoder结构递归自编码器&lpar;tensorflow&rpar;不能调用GPU进行计算的问题（非机器配置，而是网络结构的问题）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmvx6e9.html">machine learning model&lpar;algorithm model&rpar; &period;vs&period; statistical model</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjyzw08.html">&lbrack;VS2015&rsqb; &lbrack;asp&period;net&rsqb; 允许远程访问本机正在DEBUG的服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zk62g18.html">查询会龄 sql部分</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
